theory Semantics
imports Syntax

begin

consts Val :: "tm set"
syntax
  "_Val" :: "tm \<Rightarrow> bool"   ("value")
translations
  "value e" \<rightleftharpoons> "e \<in> Val"

inductive Val
  intros
  v_abs[intro]  : "value (\<lambda>[\<tau>]. e)"

inductive_cases value_elim[elim]: "value v"

consts Eval :: "(tm * tm) set"
syntax
  "_EVal" :: "tm \<Rightarrow> tm \<Rightarrow> bool"   ("_ \<hookrightarrow> _" [80,80] 80)
translations
  "e1\<hookrightarrow>e2" \<rightleftharpoons> "(e1, e2) \<in> Eval"

inductive Eval
  intros
  e_app_p1[intro!] : "\<lbrakk> e1\<hookrightarrow>e1' \<rbrakk> \<Longrightarrow> e1\<cdot>e2 \<hookrightarrow> e1'\<cdot>e2"
  e_app_p2[intro!] : "\<lbrakk> value v1; e2\<hookrightarrow>e2' \<rbrakk> \<Longrightarrow> v1\<cdot>e2 \<hookrightarrow> v1\<cdot>e2'"
  e_beta[intro!]   : "\<lbrakk> value v2 \<rbrakk> \<Longrightarrow> (\<lambda>[\<tau>].e1)\<cdot>v2 \<hookrightarrow> vsubst_tm v2 0 e1"

consts makes_progress :: "tm \<Rightarrow> bool"
defs makes_progress[simp]: "makes_progress e == \<exists>e'. e \<hookrightarrow> e'"

consts not_stuck :: "tm \<Rightarrow> bool"
defs not_stuck[simp]: "not_stuck e == value e \<or> makes_progress e"

consts EvalMany :: "(tm * tm) set"
syntax
  "_EValM" :: "tm \<Rightarrow> tm \<Rightarrow> bool"   ("_ '\<hookrightarrow>* _" [80,80] 80)
translations
  "e1 \<hookrightarrow>* e2" \<rightleftharpoons> "(e1, e2) \<in> EvalMany"

inductive EvalMany
  intros
  e_refl[intro!]  : "e \<hookrightarrow>* e"
  e_trans[intro!] : "\<lbrakk> e \<hookrightarrow> e'; e' \<hookrightarrow>* e'' \<rbrakk> \<Longrightarrow> e \<hookrightarrow>* e''"

end
